<template>
  <!--pages/home/main.wxml-->
  <div class='container' >
    <!--首页轮播图 -->
    <div class='logo'>
      <swiper class="swiper" indicator-dots="true" indicator-active-color	="#C98E52"  circular ="true" autoplay="true" interval="5000" duration="1000">
        <block v-for="(item, index) in imgUrls" :index="index" :key="key">
          <swiper-item>
            <image :src="item" class="slide-image" mode="aspectFill" />
          </swiper-item>
        </block>
      </swiper>
      <!-- <div class="dots">
          <block v-for="(item, index) in imgUrls" :index="index" :key="key">
          <div class="dot{{index == swiperCurrent ? ' active' : ''}}"></div>
          </block>
     </div> -->
    </div>
    <!--8848logo  -->
    <div class='text'>
      <img src="" alt="" id="text" :src="tipBg" :style="{top:permission?'-25'+'px':'-38'+'px'}"/>
      <div class='welcome' style="font-family: GujaratiMT;">WELCOME</div>
      <div class='tip' >{{helloWord}}</div>
      <div class='tips'>{{helloDetail}}</div>
    </div>
    <!--电子保卡  -->
    <div class='elecard'>
      <div class='title'>
        <text id="title1">电子保卡</text>
      </div>
      <div class='card' >
        <img id='img1' :src="eleUrl1" @click="cardadd"/>
        <img id="img2" :src="eleUrl2" @click="cardcancel"/>
      </div>
      <div class='card2'>
        <img id='img3' :src="eleUrl3" @click="findcard
"/>
        <img id='img4' :src="eleUrl4" @click="cardlist"/>
      </div>
    </div>

    <!--首页团队管理  -->
    <div class='team'>
      <div class='team_title'>
        <text id="title1">团队管理</text>
      </div>
      <div class='card3'>
        <img id='img5' :src="teamUrl1" @click="myteam"/>
        <img id="img6" :src="teamUrl2" @click="cardtoday"/>
      </div>
    </div>
    <!--弹出栏-->
    <v-hintbox :hintbox="hintbox" @close="close" ></v-hintbox>

  </div>
</template>
<script type="text/ecmascript-6">
  import config from '@/config'
  import {VeevlinkLogin,VeevlinkIslogin,VeevlinkClient,VeevlinkData} from '@/utils/base'
  import {get,showToast,setStorageSync,getStorageSync,scanCode} from '../../util'
  import store from '@/store'
  import hintbox from '@/components/hintbox/hintbox.vue'
  let mta= require('@/utils/mta_analysis.js');
  export default {
    data(){
      return{
        permission: true,
        clientHeight:wx.getSystemInfowindowHeight,
        hintbox:{
          text :'',
          show : false
        },
        contactId:"",
        sncode:"",
        VerificationCodeEntity:"",
        datas:{},
        helloWord: '',
        helloDetail: '',
        logoUrl: config.url + 'banner.png',
        eleUrl1: config.url +'card-home-entrycarecard.png',
        eleUrl2: config.url + "card-home-cancelcarecard.png",
        eleUrl3: config.url +'card-home-searchcarecard.png',
        eleUrl4: config.url +'card-home-carecardlist.png',
        teamUrl1: config.url +'card-home-myteam.png',
        teamUrl2: config.url + "card-home-myteam-carecardlist.png",
        imgUrls: [],
        indicatorDots: true,
        autoplay: true,
        interval: 5000,
        duration: 1000,
        swiperCurrent: 0,
        //    校验验证码
        firstStr:["0", "1", "2", "3", "4", "5", "6", "7", "8", "9","A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "S", "Y", "Z"],
        secondStr:[ "0", "1", "2", "3", "4", "5", "6", "7", "8", "9","0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "1", "2", "3", "4", "5"],
        SN_CRC_NORMAL:"26",
        weightNumber:[7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2, 1],
        checknumber:[1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2],
        tipBg: config.url + 'pic-home-background.png',
        tipMsg:"",
        check:"",
        sntrue:"",
        flag: false
      }

    },
    components:{
      'v-hintbox' : hintbox
    },
    methods:{
      close(){
        this.hintbox.show = false;
        this.hintbox.text = '';
      },
      swiperChange: function(e){
        this.setData({
          swiperCurrent: e.detail.current
        })
      },
      //调用此方法，传入SN码
      //方法返回true/false，true：SN码符合规则，false：SN码不符合规则
      checkSnCrc(snNumber)
      {
        let that = this;
        var modelStr = snNumber.substring(0, 2);
        if(modelStr == "M5")
        {
          that.checkSnCrcForM5(snNumber);
          that.sntrue = that.checkSnCrcForM5(snNumber);

        }
        else
        {
          that.checkSnCrcForM4(snNumber);
          that.sntrue = that.checkSnCrcForM4(snNumber);
        }
      },

      //校验M4或者M3系列的SN码，校验规则为：开头为“M3”或者“M4”，并且长度为16位
      checkSnCrcForM4(snNumber)
      {
        var modelStr = snNumber.substring(0, 2);
        console.log("@输入的SN ："+snNumber);
        console.log("@系列为 ："+modelStr);
        console.log("@长度为 ："+snNumber.length);
        if((modelStr == 'M4' || modelStr == 'M3') && snNumber.length == 16)
        {
          return true;
        }
        else
        {
          return false;
        }
      },

      //校验M5系列的SN码
      checkSnCrcForM5(snNumber)
      {
        console.log("=====snNumber：",snNumber);
        //AnalysisSN(snNumber);
        var checkCrcData = snNumber.substring(15, 16); //最后一位校验码
        var sncrcStr="";
        for (var j=0; j<15; j++) {
          var temp = snNumber.substring(j, j+1);
          for (var k=0; k<36; k++) {
            if(temp == firstStr[k]){
              sncrcStr=sncrcStr + secondStr[k];
              break;
            }
          }
        }
        console.log("@输入的SN ："+snNumber);
        console.log("@经过第一级处理的SN ："+sncrcStr);
        var strCRC = generateSnCrc(sncrcStr+SN_CRC_NORMAL);
        console.log("@生成的校验码是 ："+strCRC);
        return strCRC==checkCrcData;
      },
      generateSnCrc(snFirstStr)
      {
        var verify = 0;
        snFirstStr = snFirstStr.substring(0, 17);            // 获取身份证号码中的前17位
        var sum = 0;

        var wi=new Array(17)                               // 创建int型数组
        for (var i = 0; i < 17; i++) {                           // 循环向数组赋值
          var strid = snFirstStr.substring(i, i + 1);
          wi[i] = strid;
        }

        for (var i = 0; i < 17; i++) {                       // 循环遍历数组
          sum = sum + parseInt(weightNumber[i]) * parseInt(wi[i]) ;            // 对17位本利码加权求和
        }
        console.log("=====sum:",sum);
        verify = sum % 11;                             // 取模
        console.log("=====verify:",verify);
        if (verify == 2) {                                  // 如果模为2，则返回“X”
          return "X";
        } else {
          console.log("========checknumber[verify]:"+checknumber[verify]);
          return String(checknumber[verify]);      // 否则返回对应的校验码
        }
      },
      cardadd(){
//         mta.Event.stat('88481001',{'88480001':'true'})
        let that = this;
        console.log("录入保卡");
        config.href(config.CardAdd);
        //  wx.scanCode({
        //      success: (res) => {
        //           console.log(res)
        //           wx.setStorageSync('sncode',res.result);

        //            this.checkSnCrc(res.result);
        //            console.log(that.sntrue);
        //            if(that.sntrue === true){
        //                that.check = true;
        //                wx.setStorageSync('check',that.check);
        //                // this.getCode();
        //                console.log('sn码验证成功');
        //            }else{
        //                that.check = false;
        //                wx.setStorageSync('check',that.check);
        //             //    that.hintbox.show = true;
        //             //    that.hintbox.text = '当前SN码验证出错，请确认SN码是否正确！';
        //                console.log('sn码验证失败');
        //            }
        //       },
        //       fail: (res) =>{
        //           console.log(res);
        //       }
        //       });
      },
      cardcancel(){
        let that = this;
        console.log("撤销保卡");
        config.href(config.CardCancel);

      },
      findcard(){
        console.log("查找保卡");
        config.href(config.CardQuery);
      },
      cardlist(){
        console.log("保卡清单");
        config.href(config.CardListUser);
      },
      myteam(){
        console.log("我的团队");
        config.href(config.Group);

      },
      cardtoday(){
        console.log("今日保卡清单");
        config.href(config.CardList+'?page=Home&memberid='+this.datas.contactId);
      },
      getAjax(){
        //调用首页接口
        let veevlink = VeevlinkData();
        console.log(veevlink);
        let VerificationCodeEntity =  wx.getStorageSync('VerificationCodeEntity');
        console.log(VerificationCodeEntity);
        let that = this;
        VeevlinkClient(
          '/index?openid='+veevlink.OpenId+'&contactid='+VerificationCodeEntity.contactid+'&accountid='+VerificationCodeEntity.accountid,
          'GET',
          '',
          function (success) {
            console.log(success);
            if(success.success){
              let salesHistory = [ 'CardAdd','salesHistory',success.records[0].salesHistory];
              that.datas = success.records[0];
              store.commit('add',salesHistory);
              console.log(store.state.CardAdd.salesHistory);
              wx.setStorageSync('contactName',success.records[0].contactName);
              wx.setStorageSync('contactId',success.records[0].contactId);
              wx.setStorageSync('msg',success.records[0].appletsSetting);
              let msg =  wx.getStorageSync('msg');
              let img = JSON.parse(msg.indexImgLink)
              if(img){
                for(let i =0;i<img.length;i++){
                  that.imgUrls[i] = img[i].imgUrl;
                }
              }
              that.helloWord = msg.helloWord;
              that.helloDetail = msg.helloWordDetail;
              that.flag = true;
            }else{
              that.hintbox.show = true;
              that.hintbox.text = success.message;
            }
          },
          function (error) {
            console.log(error);
          })

      },





    },
    async onShow() {

    },
    //    页面加载时，判断用户是否登录
    async onLoad() {
      let that = this;
      wx.getSystemInfo({
        success: function(res) {
          console.log(res.windowWidth);
          if(res.windowWidth <= 375){
            that.permission  = true;
          }
          if(res.windowWidth > 375){
            that.permission  = false;
          }

        } })
      if(that.flag === false){
        that.getAjax();
      }else{
        console.log('首页接口已调用!');
      }
      mta.Page.init();

      if(wx.canIUse('getUpdateManager')){
        console.log('可以用更新版本');
        // wx.getUpdateManager 在 1.9.90 才可用，请注意兼容
        const updateManager = wx.getUpdateManager()

        updateManager.onCheckForUpdate(function (res) {
          // 请求完新版本信息的回调
          console.log(res.hasUpdate)
          if(res.hasUpdate){
          }else{
          }
        });

        updateManager.onUpdateReady(function () {
          wx.showModal({
            title: '更新提示',
            content: '新版本已经准备好，是否马上重启小程序？',
            success: function (res) {
              if (res.confirm) {
                // 新的版本已经下载好，调用 applyUpdate 应用新版本并重启
                updateManager.applyUpdate()
              }
            }
          })
        });

        updateManager.onUpdateFailed(function () {
          // 新的版本下载失败
          that.hintbox.show = true;
          that.hintbox.text = '新的版本下载失败';
        });
      }
    }

  }
</script>
<style lang="scss"  type="text/scss" scoped>
  /* pages/home/main.wxss */

  .container{
    width: 375px;
    height: 600px;
    /*margin: 0 auto;*/
    top:0;
    left:0;
    right: 0;
    .logo{
      width: 375px;
      height: 0.29rem;
      position:absolute;
      top:0;
      z-index: 999;
      .slide-image{
        background-size: 100%;
        position: absolute;
        width: 375px;
        height: 145px;
        top: 0;
        .swiper-container{
          position: relative;
        }
        .swiper-container .swiper{
          height: 290rpx;
        }
        .swiper-container .swiper .img{
          width: 100%;
          height: 0.29rem;
        }
        .swiper-container .dots{
          position: absolute;
          left: 0;
          right: 0;
          bottom: 20rpx;
          display: flex;
          justify-content: center;
        }
        .swiper-container .dots .dot{
          margin: 0 8rpx;
          width: 14rpx;
          height: 14rpx;
          background: #fff;
          border-radius: 8rpx;
          transition: all .6s;
        }
        .swiper-container .dots .dot.active{
          width: 24rpx;
          background: #f80;
        }


      }

    }
    .text{
      width: 100%;
      position:absolute;
      top: 2.4rem;
      //top:18%;
      #text{
        background-size: 100%;
        width: 100%;
        height: 6rem;
        position:absolute;
        top:-52rpx;
        //top: -52rpx;
      }
      .welcome{
        font-family: GujaratiMT;
        font-weight:bold;
        font-size: 1.28rem;
        text-align: left;
        word-spacing: 2px;
        color: #AD7B48;
        position:absolute;
        /*z-index: 999;*/
        top: 2rem;
        opacity: 0.14;
        left:0.2rem;
      }
      .tip{
        color:#ffffff;
        font-size: 0.48rem;
        text-align: left;
        position: absolute;
        /*z-index: 999;*/
        margin-left:0.42rem;
        margin-top:2.12rem;
      }
      .tips{
        color:#ffffff;
        text-align: left;
        position: absolute;
        font-size: 0.32rem;
        /*z-index: 999;*/
        margin-left:0.42rem;
        margin-top:2.88rem;
      }
    }
    .elecard{
      width: 100%;
      position: absolute;
      top: 6rem;
      background-color: #262626;
      .title{
        width:7.1rem;
        margin-left:0.4rem;
        height: 0.8rem;
        line-height: 0.8rem;
        border-bottom:0.01px solid #383838;
        #title1{
          color: #C98E52;
          font-size: 0.32rem;
          font-family: PingFangSC;
        }

      }
      .card{
        display: flex;
        flex: 1;
        padding-top: 0.2rem;
        padding-bottom:0;
        margin-left: 0.2rem;
        #img1,#img2{
          width: 3.54rem;
          height: 1.8rem;
          background-size:100%;
          box-sizing: content-box;
        }
      }
      .card2{
        display: flex;
        flex: 1;
        margin-left:0.2rem;

        #img3,#img4{
          width: 3.54rem;
          height: 1.8rem;
          background-size:100%;
          box-sizing: content-box;
        }
      }

    }
    .team{
      position:absolute;
      top:10.5rem;
      width: 100%;
      height:3.2rem;
      background-color: #262626;
      bottom:0;
      .team_title{
        width: 7.1rem;
        height: 0.8rem;
        line-height: 0.8rem;
        border-bottom:0.01px solid #383838;
        margin-left: 0.4rem;
        #title1{
          color:#C98E52;
          font-size: 0.32rem;
          font-family: PingFangSC;
          text-align: left;
        }
      }
      .card3{
        width: 7.1rem;
        height: 1.8rem;
        flex: 1;
        padding: 0.2rem;
        box-sizing: content-box;
        #img5,#img6{
          background-size: 100%;
          width: 3.54rem;
          height: 1.8rem;
          /*z-index: 999;*/
        }


      }

    }




  }

</style>
